/* OGMRip - A library for DVD ripping and encoding
 * Copyright (C) 2004-2007 Olivier Rolland <billl@users.sf.net>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 2.1 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 */

#ifndef __OGMRIP_MPEG_H__
#define __OGMRIP_MPEG_H__

#include <ogmrip-container.h>

G_BEGIN_DECLS

#define OGMRIP_TYPE_MPEG          (ogmrip_mpeg_get_type ())
#define OGMRIP_MPEG(obj)          (G_TYPE_CHECK_INSTANCE_CAST ((obj), OGMRIP_TYPE_MPEG, OGMRipMpeg))
#define OGMRIP_MPEG_CLASS(klass)  (G_TYPE_CHECK_CLASS_CAST ((klass), OGMRIP_TYPE_MPEG, OGMRipMpegClass))
#define OGMRIP_IS_MPEG(obj)       (G_TYPE_CHECK_INSTANCE_TYPE ((obj), OGMRIP_TYPE_MPEG))
#define OGMRIP_IS_MPEG_CLASS(obj) (G_TYPE_CHECK_CLASS_TYPE ((klass), OGMRIP_TYPE_MPEG))

typedef struct _OGMRipMpeg      OGMRipMpeg;
typedef struct _OGMRipMpegClass OGMRipMpegClass;
typedef struct _OGMRipMpegPriv  OGMRipMpegPriv;

struct _OGMRipMpeg
{
  OGMRipContainer parent_instance;

  OGMRipMpegPriv *priv;
};

struct _OGMRipMpegClass
{
  OGMRipContainerClass parent_class;
};

typedef enum
{
  OGMRIP_MPEG_DVD,
  OGMRIP_MPEG_VCD,
  OGMRIP_MPEG_SVCD
} OGMRipMpegFormat;

GType         ogmrip_mpeg_get_type     (void);
OGMJobSpawn * ogmrip_mpeg_new          (const gchar      *output);

void          ogmrip_mpeg_set_format   (OGMRipMpeg       *mpeg,
                                        OGMRipMpegFormat format);
gint          ogmrip_mpeg_get_format   (OGMRipMpeg       *mpeg);

G_END_DECLS

#endif /* __OGMRIP_MPEG_H__ */

